package services;

import org.springframework.dao.DataAccessException;

public interface FilmCandidateDAO {
	
	/**
	 * Creates a Film
	 * @param meetingSid int
	 * @param filmSid int
	 * @throws DataAccessException
	 */
	void create(int meetingSid, int filmSid) throws DataAccessException;
	
	/**
	 * Votes a film of a meeting
	 * @param meetingSid int
	 * @param filmSid int
	 * @throws DataAccessException
	 */
	void voteFilm(int meetingSid, int filmSid) throws DataAccessException;
	
	/**
	 * Gets points of a filmcandidate
	 * @param meetingSid int
	 * @param filmSid int
	 * @return int returned
	 * @throws DataAccessException
	 */
	int getPoints(int meetingSid, int filmSid) throws DataAccessException;
}
