package services;

import org.springframework.dao.DataAccessException;

import dto.FilmLibrary;

public interface FilmLibraryDAO {
	
	/**
	 * Adds a film to his filmlibrary
	 * @param filmSid int
	 * @param userSid String
	 * @param gotIt boolean
	 * @param seeWannaSee Boolean
	 * @throws DataAccessException
	 */
	void add(int filmSid, String userSid, boolean gotIt, Boolean seeWannaSee) throws DataAccessException;
	
	/**
	 * Update the filmlibrary
	 * @param filmSid int
	 * @param userSid String
	 * @param gotIt boolean
	 * @param seeWannaSee Boolean
	 * @throws DataAccessException
	 */
	void update(int filmSid, String userSid, boolean gotIt, Boolean seeWannaSee) throws DataAccessException;

	/**
	 * Gets a filmlibrary
	 * @param filmSid int
	 * @param userSid String
	 * @return FilmLibrary returned
	 * @throws DataAccessException
	 */
	FilmLibrary get(int filmSid, String userSid) throws DataAccessException;
}
