package services.impl;


import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataAccessException;
import org.springframework.dao.EmptyResultDataAccessException;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import services.FilmCandidateDAO;
 
@Repository
public class FilmCandidateDAOImpl implements FilmCandidateDAO{
	
	private @Autowired GeneralDAO generalDAO;
	
	@Transactional(readOnly = false)
	public void create(int meetingSid, int filmSid) throws DataAccessException{
		try{
			String query = "INSERT INTO filmcandidate (meeting_sid, film_sid, points) VALUES (?, ?, ?)";
			Object[] params = new Object[]{
				meetingSid, filmSid, 0
			};
			generalDAO.getJdbcTemplate().update(query, params);
		}
		catch (DataAccessException e) {
			throw e;
		}
	}
	
	@Transactional(readOnly = false)
	public void voteFilm(int meetingSid, int filmSid)
			throws DataAccessException {
		try{
			String query = "UPDATE filmcandidate SET points=filmcandidate.points+1 " +
					"WHERE filmcandidate.meeting_sid=? AND filmcandidate.film_sid=?";
			Object[] params = new Object[]{
				meetingSid, filmSid
			};
			generalDAO.getJdbcTemplate().update(query, params);
		}
		catch (DataAccessException e) {
			throw e;
		}
	}

	@Transactional(readOnly = true)
	public int getPoints(int meetingSid, int filmSid)
			throws DataAccessException {
		try{
			String query = "SELECT points FROM filmcandidate where meeting_sid = ? AND film_sid = ?";
			Object[] params = new Object[]{
				meetingSid, filmSid
			};
			Integer points = generalDAO.getJdbcTemplate().queryForObject(query, params, Integer.class);
			return points;
		}
		catch (EmptyResultDataAccessException e) {
			return 0;
		}
		catch (DataAccessException e) {
			throw e;
		}
	}
}